import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Calendar;
import java.text.DateFormat;
import java.io.*;
import java.net.*;

public class EMailApplet extends Applet implements ActionListener{
  public void init(){
    host=getParameter("host");
    
    setBackground(Color.white);    
    setFont(currentFont);
    
    setLayout(new BorderLayout());
    Panel p=new Panel();
    p.setLayout(new GridLayout(3,1));
    
    
    Panel sp1=new Panel();
    sp1.setLayout(new FlowLayout(FlowLayout.LEFT));
    senderLabel=new Label("     Sender:",Label.RIGHT);
    sp1.add("West",senderLabel);
    senderField=new TextField(25);
    sp1.add("East",senderField);
    p.add(sp1);
    
    Panel sp2=new Panel();
    sp2.setLayout(new FlowLayout(FlowLayout.LEFT));
    recipientLabel=new Label("  Recipient:",Label.RIGHT);
    sp2.add(recipientLabel);
    recipientField=new TextField(25);
    sp2.add(recipientField);
    p.add(sp2);
    
    Panel sp3=new Panel();
    sp3.setLayout(new FlowLayout(FlowLayout.LEFT));
    subjectLabel=new Label("    Subject:",Label.RIGHT);
    sp3.add(subjectLabel);
    subjectField=new TextField(25);
    sp3.add(subjectField);
    p.add(sp3);
    
    add("North",p);
    
    messageArea=new TextArea(15,25);
    add("Center",messageArea);
    
    Panel pButton=new Panel();
    pButton.setLayout(new GridLayout(1,2));

    
    clearButton=new Button("Clear");
    clearButton.addActionListener(this);
    pButton.add(clearButton);
    
    submitButton=new Button("Submit");
    submitButton.addActionListener(this);
    pButton.add(submitButton);
    add("South",pButton);
    
    try
    {
      URL url=new URL(getDocumentBase(),"img.gif");
      img=getImage(url);
    }
    catch(Exception e){}
    canvas=new Canvas();
    canvas.setSize(105,140);
    add("West",canvas);

  }
  
  public void update(Graphics g){
    paint(g);
  }
  
  public void actionPerformed(ActionEvent e){
    Object source=e.getSource();
    if(source==submitButton){
      EMail email=new EMail();
      email.setSenderAddress(senderField.getText());
      email.setRecipientAddress(recipientField.getText());
      email.setSubject(subjectField.getText());
      email.setMessage(messageArea.getText());
      
      SMTPClient client=null;
      if(host==null)
        client=new SMTPClient(getCodeBase().toString());
      else
        client=new SMTPClient(host);
      client.send(email);
      
      senderField.setText("");
      recipientField.setText("");
      subjectField.setText("");
      messageArea.setText("");
    }
    else{
      if(source==clearButton){
        senderField.setText("");
        recipientField.setText("");
        subjectField.setText("");
        messageArea.setText("");
      }
    }
  }
  
  public void start(){
    repaint();
  }
  
  public void paint(Graphics g)
  {
    canvas.getGraphics().drawImage(img,0,0,this);
  }
  
  private Label senderLabel,recipientLabel,subjectLabel;
  private TextField senderField,recipientField,subjectField;
  private TextArea messageArea;
  private Button submitButton,clearButton;
  private String host;
  private Canvas canvas;
  private Image img;
  private Font currentFont=new Font("Courier",Font.PLAIN,12);
  
}

class SMTPClient{

  public SMTPClient(String smtpServerHost){
    server=smtpServerHost;
  }
  
  public void send(EMail anEMailMessage){
    anEMail=anEMailMessage;
    String sender=anEMail.getSenderAddress();
    client=sender.substring(sender.indexOf("@")+1,sender.length());
    sendMessage(anEMail.toString());
  }
  
  public void sendMessage(String message){
    connect();
    initiate();
    output.print(message);
    output.flush();
    end();
    disconnect();    
  }
  
  private void connect(){
    try{
      Socket socket=new Socket(server,25);
      input=new BufferedReader(new InputStreamReader(socket.getInputStream()));
      output=new PrintWriter(new BufferedWriter(new OutputStreamWriter(socket.getOutputStream())));
    }catch(IOException e){
      System.out.println("Error connecting to the SMTP server:"+server);
      e.printStackTrace(); }
    
  }
  
  private void disconnect(){
    try{
      input.close();
      output.close();  
    }catch (IOException e){
        System.out.println("Error closing connection to the SMTP Server: "+server);
        e.printStackTrace(); }
  }
  
  private void initiate(){
    String response=null;
    try{
      output.print("HELO "+client+"\r\n");
      output.print("MAIL FROM: "+anEMail.getSenderAddress()+"\r\n");
      output.print("RCPT TO: "+anEMail.getRecipientAddress()+"\n\n");
      output.print("DATA\r\n");
      output.flush();
      response=input.readLine();  
    }catch (IOException e){
        System.out.println("Error initializing connection to the SMTP server: "+server);
        System.out.println("Error from server: "+response);
        e.printStackTrace(); }
  }
  
  private void end(){
    String response=null;
    try{
      output.print("\r\n.\r\n");
      output.print("QUIT\r\n");
      output.flush();
      response=input.readLine();          
    
    }catch (IOException e){
      System.out.println("Error disconnecting from the SMTP server: "+server);
      System.out.println("Error from server: "+response);
      e.printStackTrace();}
  }
  
  private BufferedReader input;
  private PrintWriter output;
  private EMail anEMail;
  private String server;
  private String client;
}

class EMail{
  
  public EMail(){
    date=Calendar.getInstance();
  }
  
  public void setSenderAddress(String anEMailAddress){
    senderAddress=anEMailAddress;
  }
  
  public String getSenderAddress(){
    return senderAddress;
  }
  
  public void setRecipientAddress(String anEMailAddress){
    recipientAddress=anEMailAddress;    
  }
  
  public String getRecipientAddress(){
    return recipientAddress;
  }
  
  public void setDate(Calendar aDate){
    date=aDate;
  }
  
  public Calendar getDate(){
    return date;
  }
  
  public void setSubject(String aSubject){
    subject=aSubject;
  }
  
  public String getSubject(){
    return subject;
  }
  
  public void setMessage(String aMessage){
    message=aMessage;
  }
  
  public String getMessage(){
    return message;
  }
  
  public String toString(){
    DateFormat dateFormat=DateFormat.getDateTimeInstance(DateFormat.FULL,DateFormat.LONG);
    return "From: "+senderAddress+"\n"+
           "To: "+recipientAddress+"\n"+
           "Subject: "+subject+"\n"+
           "Date: "+dateFormat.format(date.getTime() )+"\n\n"+message;
  }
  
  private String senderAddress;
  private String recipientAddress;
  private Calendar date;
  private String subject;
  private String message;
  
}
